commit 195bf3719bb6d673f6730b221cfcd0dfec0281b4
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Sun Nov 2 14:31:22 2025 +0000

        Revert "Retire identd support"
    
        This reverts commit 106c3eb8ee31297588d5ec0555195be966dfd7b2.

diff --git a/src/src/configure.default b/src/src/configure.default
index c05ed182e..633c6539e 100644
--- a/src/src/configure.default
+++ b/src/src/configure.default
@@ -260,6 +260,21 @@ host_lookup = *
 dns_dnssec_ok = 1
 
 
+# The settings below cause Exim to make RFC 1413 (ident) callbacks
+# for all incoming SMTP calls. You can limit the hosts to which these
+# calls are made, and/or change the timeout that is used. If you set
+# the timeout to zero, all RFC 1413 calls are disabled. RFC 1413 calls
+# are cheap and can provide useful information for tracing problem
+# messages, but some hosts and firewalls have problems with them.
+# This can result in a timeout instead of an immediate refused
+# connection, leading to delays on starting up SMTP sessions.
+# (The default was reduced from 30s to 5s for release 4.61. and to
+# disabled for release 4.86)
+#
+#rfc1413_hosts = *
+#rfc1413_query_timeout = 5s
+
+
 # Enable an efficiency feature.  We advertise the feature; clients
 # may request to use it.  For multi-recipient mails we then can
 # reject or accept per-user after the message is received.
diff --git a/src/src/daemon.c b/src/src/daemon.c
index 824fe0187..a31ef1eb5 100644
--- a/src/src/daemon.c
+++ b/src/src/daemon.c
@@ -479,9 +479,20 @@ if (pid == 0)
   signal(SIGTERM, SIG_DFL);
   signal(SIGINT, SIG_DFL);
 
-  /* Set up the fullhost information in case there is no HELO/EHLO. */
+  /* Attempt to get an id from the sending machine via the RFC 1413
+  protocol. We do this in the sub-process in order not to hold up the
+  main process if there is any delay. Then set up the fullhost information
+  in case there is no HELO/EHLO.
 
+  If debugging is enabled only for the daemon, we must turn if off while
+  finding the id, but turn it on again afterwards so that information about the
+  incoming connection is output. */
+
+  if (f.debug_daemon) debug_selector = 0;
+  verify_get_ident(IDENT_PORT);
   host_build_sender_fullhost();
+  debug_selector = save_debug_selector;
+
   DEBUG(D_any)
     debug_printf("Process %d is handling incoming connection from %s\n",
       (int)getpid(), sender_fullhost);
diff --git a/src/src/exim.c b/src/src/exim.c
index 88ed33a8e..df343b5a1 100644
--- a/src/src/exim.c
+++ b/src/src/exim.c
@@ -5465,7 +5465,9 @@ if (raw_active_hostname)
 /* Handle host checking: this facility mocks up an incoming SMTP call from a
 given IP address so that the blocking and relay configuration can be tested.
 Unless a sender_ident was set by -oMt, we discard it (the default is the
-caller's login name). */
+caller's login name). An RFC 1413 call is made only if we are running in the
+test harness and an incoming interface and both ports are specified, because
+there is no TCP/IP call to find the ident for. */
 
 if (host_checking)
   {
@@ -5473,7 +5475,12 @@ if (host_checking)
   int size;
 
   if (!sender_ident_set)
+    {
     sender_ident = NULL;
+    if (f.running_in_test_harness && sender_host_port
+       && interface_address && interface_port)
+      verify_get_ident(test_harness_identd_port);
+    }
 
   /* In case the given address is a non-canonical IPv6 address, canonicalize
   it. Use the compressed form for IPv6. */
@@ -5496,6 +5503,7 @@ if (host_checking)
   debug_file = stderr;
   debug_fd = fileno(debug_file);
   dprintf(smtp_out_fd, "\n**** SMTP testing session as if from host %s\n"
+    "**** but without any ident (RFC 1413) callback.\n"
     "**** This is not for real!\n\n",
       sender_host_address);
 
@@ -5607,12 +5615,14 @@ sendmail error modes other than -oem ever actually used? Later: yes.) */
 if (!smtp_input) error_handling = arg_error_handling;
 
 /* If this is an inetd call, ensure that stderr is closed to prevent panic
-logging being sent down the socket. */
+logging being sent down the socket and make an identd call to get the
+sender_ident. */
 
 else if (f.is_inetd && !atrn_mode)
   {
   (void)fclose(stderr);
   exim_nullstd();                       /* Re-open to /dev/null */
+  verify_get_ident(IDENT_PORT);
   host_build_sender_fullhost();
   set_process_info("handling incoming connection from %s via inetd",
     sender_fullhost);
diff --git a/src/src/exim.h b/src/src/exim.h
index fa56f2c2c..5b931e9f4 100644
--- a/src/src/exim.h
+++ b/src/src/exim.h
@@ -156,6 +156,8 @@ configuration file.  We also use this for some other short strings, such
 as queue names.
 Also TLS ciphersuite name (no real known limit since the protocols use
 integers, but max seen in reality is 45 octets).
+
+RFC 1413 gives us the 512 limit on IDENT protocol userids.
 */
 
 #define EXIM_EMAILADDR_MAX     256
diff --git a/src/src/functions.h b/src/src/functions.h
index 223723b81..98dc1a461 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -697,6 +697,7 @@ extern int     verify_check_given_host(const uschar **, const host_item *);
 extern int     verify_check_this_host(const uschar **, unsigned int *,
 	         const uschar*, const uschar *, const uschar **);
 extern address_item *verify_checked_sender(const uschar *);
+extern void    verify_get_ident(int);
 extern void    verify_quota(uschar *);
 extern int     verify_quota_call(const uschar *, int, int, uschar **);
 extern BOOL    verify_sender(int *, uschar **);
diff --git a/src/src/globals.c b/src/src/globals.c
index be2b7ec13..c8636e191 100644
--- a/src/src/globals.c
+++ b/src/src/globals.c
@@ -707,6 +707,7 @@ bit_table debug_options[]      = { /* must be in alphabetical order and use
   BIT_TABLE(D, filter),
   BIT_TABLE(D, hints_lookup),
   BIT_TABLE(D, host_lookup),
+  BIT_TABLE(D, ident),
   BIT_TABLE(D, interface),
   BIT_TABLE(D, lists),
   BIT_TABLE(D, load),
@@ -989,6 +990,7 @@ bit_table log_options[]        = { /* must be in alphabetical order,
   BIT_TABLE(L, dnssec),
   BIT_TABLE(L, etrn),
   BIT_TABLE(L, host_lookup_failed),
+  BIT_TABLE(L, ident_timeout),
   BIT_TABLE(L, incoming_interface),
   BIT_TABLE(L, incoming_port),
   BIT_TABLE(L, lost_incoming_connection),
@@ -1238,6 +1240,8 @@ int     retry_maximum_timeout  = 0;        /* set from retry config */
 retry_config  *retries         = NULL;
 const uschar *return_path            = NULL;
 int     rewrite_existflags     = 0;
+uschar *rfc1413_hosts          = US"@[]";
+int     rfc1413_query_timeout  = 0;
 uid_t   root_gid               = ROOT_GID;
 uid_t   root_uid               = ROOT_UID;
 
@@ -1399,6 +1403,7 @@ uid_t   system_filter_uid      = (uid_t)-1;
 
 blob	tcp_fastopen_nodata    = { .data = NULL, .len = 0 };
 tfo_state_t tcp_out_fastopen   = TFO_NOT_USED;
+int	test_harness_identd_port  = IDENT_PORT;
 int     test_harness_load_avg  = 0;
 int     thismessage_size_limit = 0;
 int     timeout_frozen_after   = 0;
diff --git a/src/src/globals.h b/src/src/globals.h
index ccd790cc2..ddf78b4d8 100644
--- a/src/src/globals.h
+++ b/src/src/globals.h
@@ -919,6 +919,8 @@ extern int     retry_maximum_timeout;  /* The maximum timeout */
 extern const uschar *return_path;            /* Return path for a message */
 extern BOOL    return_path_remove;     /* Remove return-path headers */
 extern int     rewrite_existflags;     /* Indicate which headers have rewrites */
+extern uschar *rfc1413_hosts;          /* RFC hosts */
+extern int     rfc1413_query_timeout;  /* Timeout on RFC 1413 calls */
 /* extern BOOL    rfc821_domains;  */       /* If set, syntax is 821, not 822 => being abolished */
 extern uid_t   root_gid;               /* The gid for root */
 extern uid_t   root_uid;               /* The uid for root */
@@ -1059,6 +1061,7 @@ extern BOOL    system_filter_uid_set;  /* TRUE if uid set */
 extern blob    tcp_fastopen_nodata;    /* for zero-data TFO connect requests */
 extern BOOL    tcp_nodelay;            /* Controls TCP_NODELAY on daemon */
 extern tfo_state_t tcp_out_fastopen;   /* TCP fast open */
+extern int     test_harness_identd_port; /* For use when testing */
 extern int     test_harness_load_avg;  /* For use when testing */
 extern int     thismessage_size_limit; /* Limit for this message */
 extern int     timeout_frozen_after;   /* Max time to keep frozen messages */
diff --git a/src/src/macros.h b/src/src/macros.h
index 2e0efc9b8..75563d86b 100644
--- a/src/src/macros.h
+++ b/src/src/macros.h
@@ -90,6 +90,10 @@ don't make the file descriptors two-way. */
 #define pipe_read  0
 #define pipe_write 1
 
+/* The RFC 1413 ident port */
+
+#define IDENT_PORT 113
+
 /* A macro to simplify testing bits in lookup types */
 
 #define mac_islookup(li,b) ((li)->type & (b))
@@ -381,25 +385,26 @@ enum {
   DEBUG_BIT(filter),
   DEBUG_BIT(hints_lookup),
   DEBUG_BIT(host_lookup),
+  DEBUG_BIT(ident),
   DEBUG_BIT(interface),
   DEBUG_BIT(lists),
-  DEBUG_BIT(load),
-  DEBUG_BIT(lookup),		/* 15 */
+  DEBUG_BIT(load),		/* 15 */
+  DEBUG_BIT(lookup),
   DEBUG_BIT(memory),
   DEBUG_BIT(noutf8),
   DEBUG_BIT(pid),
   DEBUG_BIT(process_info),
   DEBUG_BIT(queue_run),
   DEBUG_BIT(receive),
-  DEBUG_BIT(resolver),
-  DEBUG_BIT(retry),		/* 23 */
+  DEBUG_BIT(resolver),		/* 23 */
+  DEBUG_BIT(retry),
   DEBUG_BIT(rewrite),
   DEBUG_BIT(route),
   DEBUG_BIT(timestamp),
   DEBUG_BIT(tls),
   DEBUG_BIT(transport),
   DEBUG_BIT(uid),
-  DEBUG_BIT(verify),		/* 30 - one spare! */
+  DEBUG_BIT(verify),		/* 31 */
 };
 
 /* Multi-bit debug masks */
@@ -469,6 +474,7 @@ enum logbit {
   Li_dkim,
   Li_dkim_verbose,
   Li_dnssec,
+  Li_ident_timeout,
   Li_incoming_interface,
   Li_incoming_port,
   Li_millisec,
diff --git a/src/src/readconf.c b/src/src/readconf.c
index f4da20b6a..1fe2b2bfc 100644
--- a/src/src/readconf.c
+++ b/src/src/readconf.c
@@ -298,6 +298,9 @@ static optionlist optionlist_config[] = {
   { "retry_interval_max",       opt_time,        {&retry_interval_max} },
   { "return_path_remove",       opt_bool,        {&return_path_remove} },
   { "return_size_limit",        opt_mkint|opt_hidden, {&bounce_return_size_limit} },
+  { "rfc1413_hosts",            opt_stringptr,   {&rfc1413_hosts} },
+  { "rfc1413_port",		opt_int|opt_hidden, {&test_harness_identd_port} },
+  { "rfc1413_query_timeout",    opt_time,        {&rfc1413_query_timeout} },
   { "sender_unqualified_hosts", opt_stringptr,   {&sender_unqualified_hosts} },
   { "slow_lookup_log",          opt_int,         {&slow_lookup_log} },
   { "smtp_accept_keepalive",    opt_bool,        {&smtp_accept_keepalive} },
diff --git a/src/src/verify.c b/src/src/verify.c
index a3ade640b..a12e74ce6 100644
--- a/src/src/verify.c
+++ b/src/src/verify.c
@@ -2779,6 +2779,162 @@ return yield;
 
 
 
+/*************************************************
+*            Get RFC 1413 identification         *
+*************************************************/
+
+/* Attempt to get an id from the sending machine via the RFC 1413 protocol. If
+the timeout is set to zero, then the query is not done. There may also be lists
+of hosts and nets which are exempt. To guard against malefactors sending
+non-printing characters which could, for example, disrupt a message's headers,
+make sure the string consists of printing characters only.
+
+Argument:
+  port    the port to connect to; usually this is IDENT_PORT (113), but when
+          running in the test harness with -bh a different value is used.
+
+Returns:  nothing
+
+Side effect: any received ident value is put in sender_ident (NULL otherwise)
+*/
+
+void
+verify_get_ident(int port)
+{
+client_conn_ctx ident_conn_ctx = {0};
+int host_af, qlen;
+int received_sender_port, received_interface_port, n;
+uschar *p;
+blob early_data;
+uschar buffer[2048];
+
+/* Default is no ident. Check whether we want to do an ident check for this
+host. */
+
+sender_ident = NULL;
+if (rfc1413_query_timeout <= 0 || verify_check_host(&rfc1413_hosts) != OK)
+  return;
+
+DEBUG(D_ident) debug_printf("doing ident callback\n");
+
+/* Set up a connection to the ident port of the remote host. Bind the local end
+to the incoming interface address. If the sender host address is an IPv6
+address, the incoming interface address will also be IPv6. */
+
+host_af = Ustrchr(sender_host_address, ':') == NULL ? AF_INET : AF_INET6;
+if ((ident_conn_ctx.sock = ip_socket(SOCK_STREAM, host_af)) < 0) return;
+
+if (ip_bind(ident_conn_ctx.sock, host_af, interface_address, 0) < 0)
+  {
+  DEBUG(D_ident) debug_printf("bind socket for ident failed: %s\n",
+    strerror(errno));
+  goto END_OFF;
+  }
+
+/* Construct and send the query. */
+
+qlen = snprintf(CS buffer, sizeof(buffer), "%d , %d\r\n",
+  sender_host_port, interface_port);
+early_data.data = buffer;
+early_data.len = qlen;
+
+/*XXX we trust that the query is idempotent */
+if (ip_connect(ident_conn_ctx.sock, host_af, sender_host_address, port,
+		rfc1413_query_timeout, &early_data) < 0)
+  {
+  if (errno == ETIMEDOUT && LOGGING(ident_timeout))
+    log_write(0, LOG_MAIN, "ident connection to %s timed out",
+      sender_host_address);
+  else
+    DEBUG(D_ident) debug_printf("ident connection to %s failed: %s\n",
+      sender_host_address, strerror(errno));
+  goto END_OFF;
+  }
+
+/* Read a response line. We put it into the rest of the buffer, using several
+recv() calls if necessary. */
+
+p = buffer + qlen;
+
+for (;;)
+  {
+  uschar *pp;
+  int count;
+  int size = sizeof(buffer) - (p - buffer);
+
+  if (size <= 0) goto END_OFF;   /* Buffer filled without seeing \n. */
+  count = ip_recv(&ident_conn_ctx, p, size, time(NULL) + rfc1413_query_timeout);
+  if (count <= 0) goto END_OFF;  /* Read error or EOF */
+
+  /* Scan what we just read, to see if we have reached the terminating \r\n. Be
+  generous, and accept a plain \n terminator as well. The only illegal
+  character is 0. */
+
+  for (pp = p; pp < p + count; pp++)
+    {
+    if (*pp == 0) goto END_OFF;   /* Zero octet not allowed */
+    if (*pp == '\n')
+      {
+      if (pp[-1] == '\r') pp--;
+      *pp = 0;
+      goto GOT_DATA;             /* Break out of both loops */
+      }
+    }
+
+  /* Reached the end of the data without finding \n. Let the loop continue to
+  read some more, if there is room. */
+
+  p = pp;
+  }
+
+GOT_DATA:
+
+/* We have received a line of data. Check it carefully. It must start with the
+same two port numbers that we sent, followed by data as defined by the RFC. For
+example,
+
+  12345 , 25 : USERID : UNIX :root
+
+However, the amount of white space may be different to what we sent. In the
+"osname" field there may be several sub-fields, comma separated. The data we
+actually want to save follows the third colon. Some systems put leading spaces
+in it - we discard those. */
+
+if (sscanf(CS buffer + qlen, "%d , %d%n", &received_sender_port,
+      &received_interface_port, &n) != 2 ||
+    received_sender_port != sender_host_port ||
+    received_interface_port != interface_port)
+  goto END_OFF;
+
+p = buffer + qlen + n;
+Uskip_whitespace(&p);
+if (*p++ != ':') goto END_OFF;
+Uskip_whitespace(&p);
+if (Ustrncmp(p, "USERID", 6) != 0) goto END_OFF;
+p += 6;
+Uskip_whitespace(&p);
+if (*p++ != ':') goto END_OFF;
+while (*p && *p != ':') p++;
+if (!*p++) goto END_OFF;
+Uskip_whitespace(&p);
+if (!*p) goto END_OFF;
+
+/* The rest of the line is the data we want. We turn it into printing
+characters when we save it, so that it cannot mess up the format of any logging
+or Received: lines into which it gets inserted. We keep a maximum of 127
+characters. The deconst cast is ok as we fed a nonconst to string_printing() */
+
+sender_ident = US string_printing(string_copyn(p, 127));
+DEBUG(D_ident) debug_printf("sender_ident = %s\n", sender_ident);
+
+END_OFF:
+(void)close(ident_conn_ctx.sock);
+return;
+}
+
+
+
+
 /*************************************************
 *      Match host to a single host-list item     *
 *************************************************/

